'TM1638 test program
'Tm1638$write_control, Tm1638$write_byte, (Tm1638$write_command)
'Tm1638$write_block, Tm1638$write_data, Tm1638$write_block_end
'Tm1638$select

$crystal = 8000000
$regfile = "ATtiny4313.dat"
'$regfile = "m328pdef.dat"
$hwstack = 48
$swstack = 32
$framesize = 32

Config Clockdiv = 1

'Config TM1638 connection pins:

Const Tm1638_number = 3

Tm1638_do Alias Portd.6
Tm1638_di Alias Pind.6
Tm1638_clk Alias Portd.5
Tm1638_stb Alias Portd.4
Tm1638_stb1 Alias Portb.2
Tm1638_stb2 Alias Portb.3

$include "TM1638$SE.sub"      'include TM1638 subroutines

Dim I As Byte , J As Byte

Tp1 Alias Pind.0
Config Tp1 = Input
Portd.0 = 1
Tp2 Alias Pind.1
Config Tp2 = Input
Portd.1 = 1
Tp3 Alias Pind.2
Config Tp3 = Input
Portd.2 = 1
Tp4 Alias Pind.3
Config Tp4 = Input
Portd.3 = 1

For J = 1 To Tm1638_number
  Tm1638$current = J
  Gosub Disp_tm1638$current
  Gosub Init
Next

Tm1638$current = 1
Gosub Disp_tm1638$current

Do
  Debounce Tp1 , 0 , T1 , Sub
  Debounce Tp2 , 0 , T2 , Sub
  Debounce Tp3 , 0 , T3 , Sub
  Debounce Tp4 , 0 , T4 , Sub
  Tm1638$read_keys
  For I = 1 To 4
    J = I - 1 : J = J * 2
    Tm1638$write_byte J , Tm1638$keys(i)
  Next
Loop

End

T1:
  Tm1638$write_block &B0000
  For I = 0 To 15
    Tm1638$write_data &B11111111
    Waitms 100
  Next
  Waitms 100
  Tm1638$write_block_end

  Wait 1

  For I = 1 To 4
    Tm1638$write_control &B1010
    Waitms 500
    Tm1638$write_control &B0000
    Waitms 500
  Next

  Wait 1

  For I = &B1000 To &B1111
    Tm1638$write_control I
    Waitms 200
  Next
  For I = &B1111 To &B1000 Step -1
    Tm1638$write_control I
    Waitms 200
  Next
  Tm1638$write_control &B1010

  Tm1638$write_block &B0000
  For I = 0 To 15
    Tm1638$write_data &B00000000
    Waitms 100
  Next
  Waitms 100
  Tm1638$write_block_end
Return

T2:
  J = &B00000001
  For I = 0 To 14 Step 2
    Tm1638$write_byte I , J
    Waitms 100
    Shift J , Left
  Next
  Wait 1
  While Tp2 = 0
  Wend
  For I = 14 To 0 Step -2
    Tm1638$write_byte I , &B00000000
    Waitms 100
  Next
  Wait 1
  J = &B00000001
  For I = 0 To 14 Step 2
    Tm1638$write_byte I , J
    Waitms 100
    Shift J , Left
    J = J + &B00000001
  Next
  Wait 1
  While Tp2 = 0
  Wend
  For I = 14 To 0 Step -2
    Tm1638$write_byte I , &B00000000
    Waitms 100
  Next
Return

T3:
  J = &B00000001
  For I = 1 To 15 Step 2
    Tm1638$write_byte I , J
    Waitms 100
    Shift J , Left
  Next
  Wait 1
  While Tp3 = 0
  Wend
  For I = 15 To 1 Step -2
    Tm1638$write_byte I , &B00000000
    Waitms 100
  Next
  Wait 1
  J = &B00000001
  For I = 1 To 15 Step 2
    Tm1638$write_byte I , J
    Waitms 100
    Shift J , Left
    J = J + &B00000001
  Next
  Wait 1
  While Tp3 = 0
  Wend
  For I = 15 To 1 Step -2
    Tm1638$write_byte I , &B00000000
    Waitms 100
  Next
Return

T4:
  If Tm1638$current = 1 Then
    Tm1638$current = 2
  Elseif Tm1638$current = 2 Then
    Tm1638$current = 3
  Else
    Tm1638$current = 1
  End If
  Gosub Disp_tm1638$current
Return

Init:
  Tm1638$write_control &B1010

  For I = 0 To 15
    Tm1638$write_byte I , &B11111111
    Waitms 50
  Next

  For I = 15 To 0 Step -1
    Tm1638$write_byte I , &B00000000
    Waitms 50
  Next
Return

Disp_tm1638$current:
  Config Pinb.0 = Output
  Config Pinb.1 = Output
  If Tm1638$current = 1 Then
    Portb.0 = 0
    Portb.1 = 1
  End If
  If Tm1638$current = 2 Then
    Portb.0 = 1
    Portb.1 = 0
  End If
  If Tm1638$current = 3 Then
    Portb.0 = 0
    Portb.1 = 0
  End If
Return